{this one isn't so much from inspiration as it is from hours of poring over
the source code from EB.COM and reading an assembly book borrowed from Tim
and trying to figure it out
}
{$G+}
program FontChange(input, output);

uses crt, dos;

const
  DrawChar = '';
  EraseChar = ''{''};
  Tall = 16;

type
  CharType = array[1..Tall] of byte;
  FontType = array[0..255] of CharType;
  BChar = string[2];
  FileType = file of FontType;
  BoolType = string[8];

var
  Font: FontType;
  Choice: byte;
  Regs: Registers;
  DatFile: FileType;
  XChar, YChar: byte;

Function InKey: BChar;
var
Temp: bchar;
begin
  Regs.ah := 0;
  intr($16, Regs);
  Temp[1] := Chr(Regs.AL);
  Temp[2] := Chr(Regs.AH);
  InKey := Temp;
end;

Function GetBool(achar:byte):BoolType;
var
  temp: booltype;
  x: byte;
begin
  for x := 8 downto 1 do begin
    if (achar and 1) = 1 then temp[x] := Drawchar else temp[x] := EraseChar;
    achar := achar shr 1;
  end;
  GetBool := temp;
end;

Procedure SetBool(var achar: byte; Row: booltype);
var
  x: byte;
begin
  for x := 1 to 8 do begin
    achar := achar shl 1;
    if Row[x] = DrawChar then achar := (achar or 1) else achar := (achar and 254);
  end;
end;

Procedure Color(x, y, attribute: byte);
var
  off: word;
begin
  off := ((y - 1) * 80 + x - 1) * 2 + 1;
  Move(attribute, Ptr(segB800, off)^, 1);
{  asm
    push segm
    pop ds
    mov di, off
    mov al, attribute
    mov [di], al
  end;}

end;
Function GetChar: Word;
var x, y, I: byte;
    key: bchar;
begin
  ClrScr;
  Write('Which Character: ');
  for x := 0 to 15 do begin
    for y := 0 to 15 do begin
      GotoXY(x * 2 + 1, y + 3);
      I := x * 16 + y;
      if I <> 7 then Write(Chr(I));
    end;
  end;
  Color(XChar * 2 - 1, YChar + 2, 78);
  Repeat
    Repeat
      Key := InKey;
    Until Key <> '';
    Color(XChar * 2 - 1, YChar + 2, 7);
    Case Key[2] of
      'H': begin
             YChar := YChar - 1;
             if YChar = 0 then YChar := 16;
           end;
      'M': begin
             XChar := XChar + 1;
             if XChar = 17 then XChar := 1;
           end;
      'K': begin
             XChar := XChar - 1;
             if XChar = 0 then XChar := 16;
           end;
      'P': begin
             YChar := YChar + 1;
             if YChar = 17 then YChar := 1;
           end;
    end;{case key[2] of}
    if (key[1] in [#1..#255]) and (key[1] <> #13) and (key[1] <> #27) then begin  {jump straight}
      XChar := ord(key[1]) div 16 + 1;                        {to what they}
      YChar := ord(key[1]) mod 16 + 1;                        {press}
    end;
    Color(XChar * 2 - 1, YChar + 2, 78);
  Until Key[1] in [#13, #27];
  if key[1] = #13 then GetChar := (XChar - 1) * 16 + (YChar - 1) else GetChar := $ffff;
end;

Procedure EditFont(var Font: FontType);
var
  x, y: byte;
  key: bchar;
  I: Word;
  Row: booltype;

begin
  Repeat
    I := GetChar;
    if I < 256 then begin   {if they pick a valid character, not ESC pressed}
      ClrScr;
      TextColor(15);
      Writeln('¿');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('        ');
      Writeln('');
      for y := 1 to Tall do begin
        Row := GetBool(Font[i][y]);
        GotoXY(2, y + 1);
        for x:= 1 to 8 do begin
          if Row[x] = DrawChar then begin
            TextColor(7);
            Write(DrawChar);
          end else begin
            TextColor(8);
            Write(EraseChar);
          end;{if}
        end;{for x}
      end;{for y}
      x := 2;
      y := 2;
      Row := GetBool(Font[i][y]);
      TextColor(7);
      Repeat
        GotoXY(50, 5);                               {write coordinates}
        Write('(', x - 1, ',', y - 1, ') ');
        GotoXY(x, y);
        repeat
          key := InKey;
        until key <> '';

        case key[2] of
          'H': begin
              SetBool(Font[i][y - 1], Row);       { ^ }
              y := y - 1;
              if y = 1 then y := Tall + 1;
              Row := GetBool(Font[i][y - 1]);
           end;
          'M': begin                                 { > }
              x := x + 1;
              if x = 10 then x := 2;
           end;
          'K': begin                                 { < }
               x := x - 1;
              if x = 1 then x := 9;
           end;
          'P': begin                                 { v }
             SetBool(Font[i][y - 1], Row);
             y := y + 1;
             if y = Tall + 2 then y := 2;
             Row := GetBool(Font[i][y - 1]);
           end;
        end;{case}

        if key[1] = #32 then begin                    {if space pressed}
          if Row[x - 1] = DrawChar then begin
            Row[x - 1] := EraseChar;                  {erase it}
            TextColor(8);
            Write(EraseChar);
          end else begin
            Row[x - 1] := DrawChar;                   {or else draw new one}
            TextColor(7);
            Write(DrawChar);
          end;
        end;
      until key[1] = #27;
      SetBool(Font[i][y - 1], Row);
      TextColor(7);
    end;{if I < 256}
  Until I = $ffff;
end;

Procedure LoadFont(var Font: FontType);
var FileName: string[64];
begin
  if ParamCount = 0 then begin
    ClrScr;
    Write('What file to load: ');
    Readln(FileName);
  end else FileName := ParamStr(1);
  if FileName <> '' then begin
    Assign(DatFile, FileName);
    {$I-}
    Reset(DatFile);
    if IOResult = 0 then begin
      Read(DatFile, Font);
      Close(DatFile);
      Write('File Loaded!');
    end
    else Write('File Not Found!');
    {$I+}
    if ParamCount = 0 then Readkey;
  end;
end;

Procedure SaveFont(var Font: FontType);
var FileName: string[64];
begin
  ClrScr;
  Write('What file to save as: ');
  Readln(FileName);
  if FileName <> '' then begin
    Assign(DatFile, FileName);
    ReWrite(DatFile);
    Write(DatFile, Font);
    Close(DatFile);
    Writeln('Done!');
    Readkey;
  end;
end;

Procedure ApplyFont(Font: FontType);
begin
  Regs.AX := $1110;
  Regs.BX := $1000;
  Regs.CX := $00FF;
  Regs.DX := 0;
  Regs.BP := Ofs(Font);
  Regs.ES := Seg(Font);
  Intr($10, Regs);


end;

Procedure GetSysFont(var Font: FontType);
begin
  Regs.AX := $1130;
  Regs.BX := $0600;
  intr($10, Regs);
  Move(Ptr(Regs.ES, Regs.BP)^, Font, 4096);
end;

Function MainChoice: byte;
var
  Choice: byte;

begin
  ClrScr;
  Writeln('1. Load Font');
  Writeln('2. Edit Font');
  Writeln('3. Save Font');
  Writeln('4. Apply Font');
  Writeln('5. Quit');
  repeat
    Choice := (ord(Readkey) - $30);
  until (Choice >= 1) or (Choice <= 5);
  MainChoice := Choice;
end;

begin
  if ParamCount >= 1 then begin             {if they specify a font on the}
    LoadFont(Font);                         {command line, apply it and quit}
    ApplyFont(Font);
  end else begin                            {otherwise show main menu}
    GetSysFont(Font);
    XChar := 1;
    YChar := 1;
    Repeat
      Choice := MainChoice;
      Case Choice of
        1: LoadFont(Font);
        2: EditFont(Font);
        3: SaveFont(Font);
        4: ApplyFont(Font);
        5: ;
      end;
    until Choice = 5;
  end;
end.